<template>
  <div class="view custers-new">
    <el-form inline label-position="left" label-width="140px" v-loading="loading">
      <section class="section">
        <p class="label">Select Lean-Delivery Solution</p>

        <el-row :gutter="20" class="new-claster">
          <el-col :xs="24" :sm="12" :md="8" v-for="app in applications" :key="app.id">
            <div class="select-button" :class="{ checked: cluster.type === app.type }" @click="cluster.name = app.type + '-' + getDate(), cluster.type = app.type">
              {{ app.label }}
            </div>
          </el-col>
          <el-col :xs="24" :sm="12" :md="8">
            <small>More details about that can be found <a href="https://lean-delivery.com/" target="_blank">here</a></small>
          </el-col>
        </el-row>
      </section>

      <section class="section">
        <p class="label">Deployment name</p>
        <el-row>
          <el-col :xs="24" :sm="10" :md="10" :lg="8" :xl="8">
              <el-input class="cluster-name" v-model="cluster.name" placeholder="keep epmty for autogeneration"></el-input>
          </el-col>
        </el-row>
      </section>

      <section class="section">
        <el-button type="primary" class="button blue-button" size="medium" :disabled="cluster.type === null" @click="newCluster">Create cluster</el-button>
        <el-button type="primary" class="button" size="medium" @click="gotoClusters">Back</el-button>
      </section>
    </el-form>
  </div>
</template>

<script>
export default {
  data () {
    return {
      applications: [
        { id: 0, label: 'AEM Environment', type: 'aem-env' },
        { id: 1, label: 'Hybris B2C', type: 'hybrisb2c' },
        { id: 2, label: 'SAP Hybris Delivery Platform', type: 'hybrisdp' },
        { id: 3, label: 'Oracle Commerce Delivery Platform', type: 'atgdp' },
        { id: 4, label: 'Hybris CI/CD', type: 'hybriscicd' },
        { id: 5, label: 'HTTP Artifac storage', type: 'artifactplain' },
        { id: 6, label: 'Hybris CI Environment', type: 'hybrisci' },
        { id: 7, label: 'Hybris FV Environment', type: 'hybrisfv' },
        { id: 8, label: 'Ansible Development Kit', type: 'ansibledk' },
        { id: 9, label: 'Shaper', type: 'shaper' },
        { id: 10, label: 'AEM CI/CD', type: 'aemcicd' },
        { id: 11, label: 'Pardomain', type: 'pardomain' }
      ],

      cluster: {
        id: null,
        name: null,
        type: null
      },

      console: [],

      loading: false
    }
  },

  created () {
    this.$store.dispatch('breadcrumbs', [
      { label: 'Clusters', route: { name: 'clusters' } },
      { label: 'New Deployment', route: { name: 'clusters.new' } }
    ])

    this.fetch()
  },

  updated() {
    let container = document.getElementById('logConsole')
    if (container) {
      container.scrollTop = container.scrollHeight
    }
  },

  methods: {

    getDate () {
      return this.$moment().format('MMDDYY-HHmmss');
    },

    fetch () {
      this.loading = true
      this.loading = false
    },

    newCluster () {
      this.loading = true
      this.clusterCreating = true
      this.$api.createCluster({
        name: this.cluster.name,
        type: this.cluster.type
      }).then(response => {
        return this.$api.generateNewSSHKeyByID(response.data.id).then(() => {
          this.$router.push({ name: 'clusters.view', params: { id: response.data.id }})
        })
      }).finally(() => {
        this.clusterCreating = false
        this.loading = false
      })
    },

    gotoClusters () {
      this.$router.push({ name: 'clusters' })
    }
  }
}
</script>

<style lang="scss">
.copy-text-input {
  opacity: 0;
  width: 1px;
  height: 1px;
}

.button-ssh {
  line-height: 20px;
  display: block;
  width: 100%;
  margin-bottom: 10px;
}

.select-button {
  text-transform: uppercase;
  //text-decoration: underline;
  text-align: center;
  cursor: pointer;
  //font-weight: 500;
  border: 1px solid #999999;
  border-bottom: 8px solid #999999;
  padding: 22px 30px;
  margin-bottom: 10px;
  min-height: 95px;
  box-sizing: border-box;

  &.checked {
    border-bottom: 8px solid #39C2D7;
  }
}

.input-group {
  .icon, .input {
    display: inline-block !important;
    width: auto;
  }

  .cluster-name {
    display: inline-block !important;
    width: 300px;
  }

  .icon {
    width: 36px;
    height: 36px;
    text-align: center;
    cursor: pointer;
  }
}

.console {
  background: #000;
  width: 100%;
  min-height: 200px;
  max-height: 549px;
  overflow: auto;
  padding: 10px;
  margin-top: 20px;
  border-radius: 4px;

  .line {
    color: #fff;
    font-size: 12px;
    font-family: monospace;

    .ts {
      margin-right: 5px;
      white-space: nowrap;
    }
  }
}

.danger-zone {
  .button {
    width: 100%;
    margin: 0;
    display: block;
    margin-bottom: 18px;
    background: #fff;
  }
}

.status {
  font-size: 14px;
  margin-bottom: 5px;
  color: #606266;
}

.consoleuse {
  font-size: 14px;
  margin-bottom: 5px;
  color: #fff;
  font-family: monospace;
  background: #000;
  padding: 5px;
}

.deployment {
  font-size: 14px;
  margin-bottom: 5px;
  color: #606266;

  a {
    color: #606266;
  }
}

.blue-button {
  background-color: #39C2D7!important;
  border-color: #39C2D7!important;
}
.blue-button.is-disabled {
  opacity: 0.3;
}

.new-claster {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  align-items: flex-start;
}
</style>
